open Ids
open Exprs

type t [@@deriving eq, show]
type id [@@deriving eq, ord, show]
type t_dims = Single of Dim.t | Join of Dim.t * Dim.t * Dim.t [@@deriving eq, show]
type gen = unit -> t
type accesses = (Dim.id * VarExpr.t) list  [@@deriving eq, show]

val single: Dim.t -> t_dims
val join_dims: Dim.t -> Dim.t -> t_dims
val make: ?name:string -> ?strides:(Dim.t * ConstExpr.t) list -> ?sizes:(Dim.t * ConstExpr.t) list
  -> Dim.t array -> t
val make_join: ?name:string -> ?strides:(t_dims * ConstExpr.t) list -> ?sizes:(t_dims * ConstExpr.t) list
  -> t_dims array -> t
val t_dims: t -> t_dims array
val t_dims_list: t -> t_dims list
val dims_list: t -> Dim.t list

val id: t -> id
val show_tid: t -> string

val gen_clone: t -> unit -> (t * (unit -> t))
val strides_from_size_list: t -> (t_dims * ConstExpr.t) list -> (t_dims * ConstExpr.t) list
val size: t -> ConstExpr.t
val dim_size: t -> Dim.t -> ConstExpr.t
val stride: t -> Dim.t -> ConstExpr.t option
val acc_does_access: accesses -> Dim.id -> bool
val tens_does_access: t -> Dim.id -> bool
val does_access: t -> accesses -> Dim.id -> bool
val modify_size_stride: t -> (t_dims * ConstExpr.t) list -> t
val map_stride: t -> (ConstExpr.t -> ConstExpr.t)  -> t
val modify_stride: t ->  Dim.t -> (ConstExpr.t option -> ConstExpr.t option)  -> t
val modify_accesses: accesses ->  Dim.id -> (VarExpr.t option -> VarExpr.t option)  -> accesses
val gen_access: t -> accesses -> string

val compare_dims_id: t -> Dim.id -> Dim.id -> int
val inner_dim: t -> Dim.t
